import { Client } from "@warrantdev/warrant-node";
import { Request, Response, NextFunction } from "express";
export declare type GetObjectIdFunc = (req: Request, res: Response) => string;
export declare type GetUserIdFunc = (req: Request, res: Response) => string | number | null;
export declare type OnAuthorizeFailure = (req: Request, res: Response) => any;
export declare type HasPermissionMiddleware = (permissionId: string) => (req: Request, res: Response, next?: NextFunction) => void;
export declare type HasAccessMiddleware = (objectType: string, getObjectId: GetObjectIdFunc, relation: string) => (req: Request, res: Response, next?: NextFunction) => void;
export interface WarrantConfig {
    client: Client;
    getUserId: GetUserIdFunc;
    getObjectId?: GetObjectIdFunc;
    onAuthorizeFailure?: OnAuthorizeFailure;
}
export interface WarrantMiddleware {
    hasPermission: HasPermissionMiddleware;
    hasAccess: HasAccessMiddleware;
}
export declare function createMiddleware(config: WarrantConfig): WarrantMiddleware;
